<template>
  <div class="mod-config">
    <basic-container>
      <el-tabs
        v-model="activeName"
        @tab-click="handleClick"
        style="margin-left:10px;margin-right:10px;"
      >
        <el-tab-pane label="段长合并" name="first"
          ><ctable
            :table="table"
            @handleSelectionChange="handleSelectionChange"
            @objectSpanMethod="objectSpanMethod(arguments)"
            :searchList="searchList"
            :uploadInfo="uploadInfo"
            :prelang="prelang"
            :options="options"
            :paramObj="paramObj"
            :bottomOffset="65"
            :ajaxFun="ajaxFun"
            ref="segmentmergeTable"
          >
            <template #toolbar></template> </ctable
        ></el-tab-pane>
        <el-tab-pane label="任务单制作" name="second">
          <ctable
            :table="taskTable"
            @handleSelectionChange="taskHandleSelectionChange"
            @inputEnterEvent="inputEnterHandler"
            :searchList="taskSearchList"
            :uploadInfo="taskUploadInfo"
            :prelang="taskPrelang"
            :options="taskOptions"
            :paramObj="taskParamObj"
            :bottomOffset="65"
            :isShowPagination="segmentmergeTaskIsShowPagination"
            :ajaxFun="taskAjaxFun"
            ref="segmentmergeTaskTable"
            class="segmentmerge-task-table"
          >
            <template #toolbar>
              <div style="display:flex;margin-left:20px ;">
                <div
                  style="width:100px;height: 32px;line-height:32px;cursor:pointer;background-color:#006eff;border-color:#ddd;color:#fff;text-align:center;"
                  @click.stop="openOperationTechnology"
                >
                  设置起始工序
                </div>
                <div style="margin-left:20px;">
                  <el-select
                    v-model="currBeginOperation"
                    placeholder="请选择"
                    @change="changeBeginOperation"
                  >
                    <el-option
                      v-for="item in beginOperationOptions"
                      :key="item.value"
                      :label="item.label"
                      :value="item.value"
                    >
                    </el-option>
                  </el-select>
                </div>
              </div>
            </template>
          </ctable>
        </el-tab-pane>
        <el-tab-pane label="任务单查询" name="third">
          <ctable
            :table="taskDetailTable"
            @handleSelectionChange="taskDetailHandleSelectionChange"
            @objectSpanMethod="objectSpanMethodForTaskDetail(arguments)"
            :mergeCols="detailMergeCols"
            :searchList="taskDetailSearchList"
            :uploadInfo="taskDetailUploadInfo"
            :prelang="taskDetailPrelang"
            :options="taskDetailOptions"
            :paramObj="taskDetailParamObj"
            :bottomOffset="65"
            :ajaxFun="taskDetailAjaxFun"
            ref="segmentmergeTaskDetailTable"
          >
            <template #toolbar> </template>
          </ctable>
        </el-tab-pane>
      </el-tabs>
      <!-- 弹窗, 新增 / 修改 -->
      <generateTaskFormDialog
        :currshowlist.sync="showGenerateTaskForm"
        :taskList="taskMultipleSelection"
        @refreshTaskList="getTaskData"
      />
      <technologyRoutingDialog
        :currshowlist.sync="showTechnologyRouting"
        :technologyRoutingList="technologyRoutingList"
        @handleSelectionChange="setTaskOperation"
      />
      <operateDialogDialog
        :currshowlist.sync="showOperateDialog"
        :taskIds="taskIds"
        @listenToPartEvent="setOperate"
      />
      <operationTechnologyDialog
        :currshowlist.sync="showOperationTechnology"
        :operationList="operationList"
        :taskList="taskMultipleSelection"
        @selectionRouting="setTaskOperationOveride"
      />
    </basic-container>
  </div>
</template>

<script>
import {
  fetchList,
  submit,
  updateBatch,
  getAuditedOrderNoList,
  exportTaskProduce,
  taskFetchList,
  updateCustomerOrderProduceTask,
  backProduceTask,
  getPartsByOrderNo,
  taskDetailFetchList,
  getOperationsByTaskIds
} from '@/api/plan/segmentmerge'
import { getListByPartAndLength } from '@/api/basic/discmaintenance'
import { mapGetters } from 'vuex'
import ctable from '@/views/common/custom-table.vue'
import { remote } from '../../../api/admin/dict'
import { transform } from '@/util/fileTransform'
import generateTaskFormDialog from './generate-task-form'
import operateDialogDialog from './operate-dialog'
import { fetchList as getOperationList } from '@/api/technology/operation'
import technologyRoutingDialog from './technology-routing-dialog'
import operationTechnologyDialog from './operation-technology-form'
import { getRoutingByDocumentIdAndOperationId } from '@/api/technology/routing'
import getLodop from '@/util/lodop'

export default {
  data() {
    return {
      taskIds: [],
      showOperateDialog: false,
      activeName: 'first',
      ajaxFun: fetchList,
      taskAjaxFun: taskFetchList,
      taskDetailAjaxFun: taskDetailFetchList,
      addOrUpdateVisible: false,
      multipleSelection: [],
      taskMultipleSelection: [],
      taskDetailMultipleSelection: [],
      uploadInfo: {
        // 是否展示上传EXCEL以及对应的url
        isShow: false,
        url: ''
      },
      taskUploadInfo: {
        // 是否展示上传EXCEL以及对应的url
        isShow: false,
        url: ''
      },
      taskDetailUploadInfo: {
        // 是否展示上传EXCEL以及对应的url
        isShow: false,
        url: ''
      },
      prelang: 'segmentmergeTable',
      taskPrelang: 'segmentmergeTaskTable',
      taskDetailPrelang: 'segmentmergeTaskDetailTable',
      options: {
        height: 300, // 默认高度-为了表头固定
        stripe: false, // 是否为斑马纹 table
        highlightCurrentRow: false, // 是否要高亮当前行
        border: true, // 是否有纵向边框
        lazy: false, // 是否需要懒加载
        fit: true, // 列的宽度是否自撑开
        multiSelect: true, //
        isRefresh: true,
        seqNo: true,
        isShowHide: true, // 是否显示显影按钮
        isSearch: false, // 高级查询按钮
        cancelRunCreated: true,
        defaultOrderBy: { column: 'id', direction: 'desc' }
      },
      taskOptions: {
        height: 300, // 默认高度-为了表头固定
        stripe: false, // 是否为斑马纹 table
        highlightCurrentRow: false, // 是否要高亮当前行
        border: true, // 是否有纵向边框
        lazy: false, // 是否需要懒加载
        fit: true, // 列的宽度是否自撑开
        multiSelect: true, //
        isRefresh: true,
        seqNo: true,
        isShowHide: true, // 是否显示显影按钮
        isSearch: false, // 高级查询按钮
        isRowEdit: true, // 行可编辑
        cancelRunCreated: true,
        showCol: 'operationProduceQtyInfo',
        defaultOrderBy: { column: 'id', direction: 'desc' }
      },
      taskDetailOptions: {
        height: 300, // 默认高度-为了表头固定
        stripe: false, // 是否为斑马纹 table
        highlightCurrentRow: false, // 是否要高亮当前行
        border: true, // 是否有纵向边框
        lazy: false, // 是否需要懒加载
        fit: true, // 列的宽度是否自撑开
        multiSelect: true, //
        isRefresh: true,
        seqNo: true,
        isShowHide: true, // 是否显示显影按钮
        isSearch: false, // 高级查询按钮
        isRowEdit: false, // 行可编辑
        tableCellMerge: true,
        cancelRunCreated: true,
        defaultOrderBy: { column: 'id', direction: 'desc' }
      },
      searchList: [
        {
          text: '订单号',
          field: 'customerOrderNo',
          type: 'select',
          value: null,
          searchOptions: [],
          remoteFun: this.searchCusomterOrders,
          changeFun: this.querySegmentmerge
        }
      ],
      taskSearchList: [
        {
          text: '订单号',
          field: 'customerOrderNo',
          type: 'select',
          value: null,
          searchOptions: [],
          remoteFun: this.searchCusomterOrdersForTask,
          changeFun: this.taskQuerySegmentmerge
        },
        {
          text: '成品零件',
          field: 'partId',
          type: 'customSelect',
          value: null,
          searchOptions: [],
          changeFun: this.queryTaskSegmentmergeByOrderAndPartNo
        }
      ],
      taskDetailSearchList: [
        {
          text: '订单号',
          field: 'customerOrderNo',
          type: 'select',
          value: null,
          searchOptions: [],
          remoteFun: this.searchCusomterOrdersForDetail,
          changeFun: this.querySegmentmergeForDetail
        },
        {
          text: '客户名称',
          field: 'customerName',
          type: 'text',
          value: null
        },
        {
          text: '工序选择',
          field: 'operationId',
          type: 'normalSelect',
          value: null,
          searchOptions: [],
          changeFun: this.getSomething
        }
      ],
      table: {
        total: 0,
        currentPage: 1,
        pageSize: 20,
        data: [],
        // 标题
        column: [
          // 订单号
          {
            minWidth: '120',
            prop: 'otcCustomerOrderNo',
            label: '订单号',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text',
            searchInfoType: 'text'
          },
          // OTC行号
          {
            minWidth: '120',
            prop: 'otcLineNo',
            label: 'OTC行号',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text',
            searchInfoType: 'text'
          },
          // 成品缆号
          {
            minWidth: '140',
            prop: 'snNo',
            label: '成品缆号',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text',
            searchInfoType: 'text'
          },
          // 客户名称
          {
            minWidth: '140',
            prop: 'customerName',
            label: '客户名称',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text',
            searchInfoType: 'text'
          },
          // 零件号
          {
            minWidth: '140',
            prop: 'partNo',
            label: '零件号',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text',
            searchInfoType: 'text'
          },
          // 零件名称
          {
            minWidth: '140',
            prop: 'partName',
            label: '零件名称',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text',
            searchInfoType: 'text'
          },
          // 段长
          {
            minWidth: '140',
            prop: 'qty',
            label: '段长(m)',
            sort: true,
            isTrue: true,
            isEdit: true,
            isSearch: false,
            editInfoType: 'text',
            formatter: (row, column, cellValue) => {
              let formatterVal
              if (cellValue && cellValue != '') {
                formatterVal = Number(cellValue) * 1000
              } else {
                formatterVal = ''
              }
              return formatterVal
            }
          },
          // 米标
          {
            minWidth: '140',
            prop: 'meterMark',
            label: '米标',
            sort: true,
            isTrue: true,
            isEdit: true,
            isSearch: true,
            editInfoType: 'text',
            searchInfoType: 'text'
          },
          // 盘具
          {
            minWidth: '140',
            prop: 'discToolMeasurement',
            label: '盘具',
            sort: true,
            isTrue: true,
            isEdit: true,
            isSearch: true,
            editInfoType: 'text',
            searchInfoType: 'text'
          },
          // 始端
          {
            minWidth: '140',
            prop: 'begining',
            label: '始端',
            sort: true,
            isTrue: true,
            isEdit: true,
            isSearch: true,
            editInfoType: 'text',
            searchInfoType: 'text'
          },
          // 终端
          {
            minWidth: '140',
            prop: 'ending',
            label: '终端',
            sort: true,
            isTrue: true,
            isEdit: true,
            isSearch: true,
            editInfoType: 'text',
            searchInfoType: 'text'
          },
          // 用途
          {
            minWidth: '140',
            prop: 'purpose',
            label: '用途',
            sort: true,
            isTrue: true,
            isEdit: true,
            isSearch: true,
            editInfoType: 'text',
            searchInfoType: 'text'
          },
          // 自编号
          {
            minWidth: '140',
            prop: 'selfNo',
            label: '自编号',
            sort: true,
            isTrue: true,
            isEdit: true,
            isSearch: true,
            editInfoType: 'text',
            searchInfoType: 'text'
          },
          // 去向
          {
            minWidth: '140',
            prop: 'direction',
            label: '去向',
            sort: true,
            isTrue: true,
            isEdit: true,
            isSearch: true,
            editInfoType: 'text',
            searchInfoType: 'text'
          },
          // 区间
          {
            minWidth: '140',
            prop: 'section',
            label: '区间',
            sort: true,
            isTrue: true,
            isEdit: true,
            isSearch: true,
            editInfoType: 'text',
            searchInfoType: 'text'
          },

          // 印字
          {
            minWidth: '140',
            prop: 'print',
            label: '印字',
            sort: true,
            isTrue: true,
            isEdit: true,
            isSearch: true,
            editInfoType: 'text',
            searchInfoType: 'text'
          },
          // 端别
          {
            minWidth: '140',
            prop: 'endClassification',
            label: '端别',
            sort: true,
            isTrue: true,
            isEdit: true,
            isSearch: true,
            editInfoType: 'text',
            searchInfoType: 'text'
          },
          // 备注
          {
            minWidth: '140',
            prop: 'orderUploadRemark',
            label: '备注',
            sort: true,
            isTrue: true,
            isEdit: true,
            isSearch: true,
            editInfoType: 'text',
            searchInfoType: 'text'
          }
        ],
        toolbar: [
          {
            text: '合并提交',
            type: 'primary',
            barShow: true,
            fun: this.mergeSubmit
          },
          {
            text: '不合并提交',
            type: 'primary',
            barShow: true,
            fun: this.unMergeSubmit
          },
          {
            text: '编辑',
            type: 'primary',
            barShow: true,
            fun: this.editRows
          },
          {
            text: '取消',
            type: 'primary',
            barShow: false,
            fun: this.cancelEditRows
          },
          {
            text: '保存',
            type: 'primary',
            barShow: false,
            fun: this.saveSegment
          },
          {
            text: '获取盘具',
            type: 'primary',
            barShow: true,
            fun: this.getDisc
          },
          {
            text: '导出',
            barShow: true,
            fun: this.exportData
          }
        ],
        operator: null,
        operatorConfig: null
      },
      segmentmergeTaskIsShowPagination: false,
      taskTable: {
        total: 0,
        currentPage: 1,
        pageSize: 20,
        data: [],
        // 标题
        column: [
          // 订单号
          {
            minWidth: '120',
            prop: 'otcCustomerOrderNo',
            label: '订单号',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // OTC行号
          {
            minWidth: '120',
            prop: 'otcLineNo',
            label: 'OTC行号',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 成品缆号
          {
            minWidth: '140',
            prop: 'snNo',
            label: '成品缆号',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 客户名称
          {
            minWidth: '140',
            prop: 'customerName',
            label: '客户名称',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 零件号
          {
            minWidth: '140',
            prop: 'partNo',
            label: '零件号',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 零件名称
          {
            minWidth: '140',
            prop: 'partName',
            label: '零件名称',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 段长
          {
            minWidth: '140',
            prop: 'qty',
            label: '段长(m)',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text',
            formatter: (row, column, cellValue) => {
              let formatterVal
              if (cellValue && cellValue != '') {
                formatterVal = Number(cellValue) * 1000
              } else {
                formatterVal = ''
              }
              return formatterVal
            }
          },
          // 米标
          {
            minWidth: '140',
            prop: 'meterMark',
            label: '米标',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 合并缆号
          {
            minWidth: '140',
            prop: 'mergeSnNo',
            label: '合并缆号',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 起始工序
          {
            minWidth: '140',
            prop: 'operationName',
            label: '起始工序',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 工序生产长度
          {
            minWidth: '140',
            prop: 'operationProduceQty',
            label: '工序生产长度',
            sort: true,
            isTrue: true,
            isEdit: true,
            isSearch: true,
            editInfoType: 'text'
          },
          // 起始工序生产长度
          {
            minWidth: '140',
            prop: 'operationProduceQtyInfo',
            label: '起始工序长度信息',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text',
            isSplitCell: true
          },
          // 盘具
          {
            minWidth: '140',
            prop: 'discToolMeasurement',
            label: '盘具',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 始端
          {
            minWidth: '140',
            prop: 'begining',
            label: '始端',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 终端
          {
            minWidth: '140',
            prop: 'ending',
            label: '终端',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 用途
          {
            minWidth: '140',
            prop: 'purpose',
            label: '用途',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 自编号
          {
            minWidth: '140',
            prop: 'selfNo',
            label: '自编号',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 去向
          {
            minWidth: '140',
            prop: 'direction',
            label: '去向',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 区间
          {
            minWidth: '140',
            prop: 'section',
            label: '区间',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 印字
          {
            minWidth: '140',
            prop: 'print',
            label: '印字',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 端别
          {
            minWidth: '140',
            prop: 'endClassification',
            label: '端别',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 备注
          {
            minWidth: '140',
            prop: 'orderUploadRemark',
            label: '备注',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          }
        ],
        toolbar: [
          {
            text: '提交',
            type: 'primary',
            barShow: true,
            fun: this.submitTask,
            cls: 'submit-task-button'
          },
          {
            text: '批量退回',
            type: 'primary',
            barShow: true,
            fun: this.backTask,
            cls: 'back-task-button'
          }
        ],
        operator: null,
        operatorConfig: null
      },
      taskDetailTable: {
        total: 0,
        currentPage: 1,
        pageSize: 20,
        data: [],
        // 标题
        column: [
          // 订单号
          {
            minWidth: '120',
            prop: 'customerOrderNo',
            label: '订单号',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 客户名称
          {
            minWidth: '140',
            prop: 'customerName',
            label: '客户名称',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 零件号
          {
            minWidth: '140',
            prop: 'partNo',
            label: '零件号',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 零件名称
          {
            minWidth: '140',
            prop: 'partName',
            label: '零件名称',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 合并缆号
          {
            minWidth: '140',
            prop: 'mergeSnNo',
            label: '合并缆号',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 成品缆号
          {
            minWidth: '140',
            prop: 'snNo',
            label: '成品缆号',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 段长
          {
            minWidth: '140',
            prop: 'qty',
            label: '段长',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 工序缆号
          {
            minWidth: '140',
            prop: 'sn',
            label: '工序缆号',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 生产长度
          {
            minWidth: '140',
            prop: 'operationProduceQty',
            label: '生产长度',
            sort: true,
            isTrue: true,
            isEdit: true,
            isSearch: true,
            editInfoType: 'text'
          },
          // 工序
          {
            minWidth: '140',
            prop: 'operationName',
            label: '工序',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 订单说明
          {
            minWidth: '140',
            prop: 'remark',
            label: '订单说明',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 节距
          {
            minWidth: '140',
            prop: 'partPitch',
            label: '节距',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 盘具
          {
            minWidth: '140',
            prop: 'discToolMeasurement',
            label: '盘具',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 区间
          {
            minWidth: '140',
            prop: 'section',
            label: '区间',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // OTC行号
          {
            minWidth: '120',
            prop: 'otcLineNo',
            label: 'OTC行号',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          },
          // 备注
          {
            minWidth: '140',
            prop: 'orderUploadRemark',
            label: '备注',
            sort: true,
            isTrue: true,
            isEdit: false,
            isSearch: true,
            editInfoType: 'text'
          }
        ],
        toolbar: [
          {
            text: '查询',
            type: 'primary',
            barShow: true,
            fun: this.queryTaskDetail
          },
          {
            text: '标签打印',
            type: 'primary',
            barShow: true,
            fun: this.printLabel
          }
        ],
        operator: null,
        operatorConfig: null
      },
      showGenerateTaskForm: false,
      materialTypeList: [],
      paramObj: { otcCustomerOrderNo: null },
      taskParamObj: { otcCustomerOrderNo: null, partId: null },
      taskDetailParamObj: {
        customerOrderNo: null,
        customerName: null,
        operationId: null
      },
      currOperationId: null,
      currOperationName: null,
      operationList: [],
      showTechnologyRouting: false,
      technologyRoutingList: [],
      detailMergeCols: ['mergeSnNo', 'snNo'],
      showOperationTechnology: false,
      currBeginOperation: null,
      beginOperationOptions: []
    }
  },
  components: {
    ctable,
    generateTaskFormDialog,
    technologyRoutingDialog,
    operateDialogDialog,
    operationTechnologyDialog
  },
  created() {
    this.getMaterialType('material_type')
    this.getOperationList()
  },
  computed: {
    ...mapGetters(['permissions'])
  },
  methods: {
    // 起始工序选择时，触发
    changeBeginOperation() {
      const currTableData = this.$refs.segmentmergeTaskTable.getTableData()
      currTableData.forEach((item) => {
        item.operationProduceQty = null
      })
    },
    inputEnterHandler(propObj) {
      if (propObj) {
        if (propObj.prop == 'operationProduceQty') {
          const currTableData = this.$refs.segmentmergeTaskTable.getTableData()
          const operationProduceQty = propObj.row.operationProduceQty
          const mergeSnNo = propObj.row.mergeSnNo
          currTableData.forEach((item) => {
            if (item.mergeSnNo == mergeSnNo) {
              item.operationProduceQty = operationProduceQty
              // 给这个值赋值到routingOperations中的operationProduceQty
              if (item.routingOperations && item.routingOperations.length > 0) {
                // 判断是否选择了起始工序
                if (this.currBeginOperation != null) {
                  let operationProduceQtyInfo = ''
                  const operationIds = []
                  item.routingOperations.forEach((ele) => {
                    // 判断起始工序与当前行的起始工序，是否一致
                    if (this.currBeginOperation == ele.operationId) {
                      ele.operationProduceQty = operationProduceQty
                    }
                    if (operationIds.indexOf(ele.operationId) < 0) {
                      operationProduceQtyInfo =
                        operationProduceQtyInfo +
                        ele.operationName +
                        '：' +
                        (ele.operationProduceQty
                          ? ele.operationProduceQty
                          : '') +
                        ','
                      operationIds.push(ele.operationId)
                    }
                  })
                  // 设置起始工序长度
                  if (operationProduceQtyInfo.length > 0) {
                    item.operationProduceQtyInfo = operationProduceQtyInfo.substring(
                      0,
                      operationProduceQtyInfo.length - 1
                    )
                  } else {
                    item.operationProduceQtyInfo = operationProduceQtyInfo
                  }
                }
              }
            }
          })
          /* updateCustomerOrderProduceTask({
            id: propObj.row.id,
            mergeSnNo: mergeSnNo,
            operationProduceQty: operationProduceQty
          }).then((response) => {
            // this.getTaskData()
          }) */
        }
      }
    },
    openOperationTechnology() {
      if (this.taskMultipleSelection.length > 0) {
        this.currOperationId = null
        this.currOperationName = null
        this.taskMultipleSelection.forEach((item) => {
          this.taskIds.push(item.id)
        })
        getOperationsByTaskIds({ ids: this.taskIds }).then((response) => {
          console.log('response', response.data)
          const resData = response.data.data
          resData.forEach((item) => {
            this.$set(item, 'commonChecked', false)
          })
          this.operationList = resData
        })
        this.showOperationTechnology = true
      } else {
        this.$message.error('请选择需要设置工序的行')
      }
    },
    setOperation() {
      if (this.currOperationId != null) {
        if (this.taskMultipleSelection.length > 0) {
          let flag = true
          const firstTaskMultipleSelect = this.taskMultipleSelection[0]
          this.taskMultipleSelection.forEach((ele) => {
            if (
              ele.technologyDocumentId !=
              firstTaskMultipleSelect.technologyDocumentId
            ) {
              flag = false
            }
          })
          if (flag) {
            getRoutingByDocumentIdAndOperationId({
              documentId: this.taskMultipleSelection[0].technologyDocumentId,
              operationId: this.currOperationId
            }).then((response) => {
              const resData = response.data
              const routingList = resData.data
              if (routingList.length > 0) {
                // 弹出工艺路线选择框
                this.technologyRoutingList = routingList
                this.showTechnologyRouting = true
              } else {
                this.taskMultipleSelection.forEach((el) => {
                  el.operationId = this.currOperationId
                  el.operationName = this.currOperationName
                  el.routingOperations = [
                    {
                      routingId: routingList[0].id,
                      operationOrder: routingList[0].operationOrder,
                      operationId: this.currOperationId
                    }
                  ]
                })
                this.$message.success('设置成功')
              }
            })
          } else {
            this.$message.error('行记录零件不一致')
          }
        } else {
          this.$message.error('请选择需要设置的行记录')
        }
      } else {
        this.$message.error('请选择工序')
      }

      // this.showTechnologyRouting = true
    },
    setTaskOperationOveride(param) {
      this.currBeginOperation = null
      this.beginOperationOptions = []
      if (param.length > 0) {
        const routingOperations = []
        let operationName = ''
        let beginOperationOption
        for (let i = 0; i < param.length; i++) {
          operationName = operationName + param[i].operationName + '；'
          param[i].routingList.forEach((item) => {
            routingOperations.push({
              routingId: item.id,
              operationOrder: item.operationOrder,
              isGenerateSn: item.isGenerateSn,
              operationId: param[i].operationId,
              operationName: param[i].operationName
            })
          })
          beginOperationOption = {
            value: param[i].operationId,
            label: param[i].operationName
          }
          this.beginOperationOptions.push(beginOperationOption)
        }
        this.taskMultipleSelection.forEach((el) => {
          el.operationName = operationName
          el.routingOperations = routingOperations
        })
        this.$message.success('设置成功')
      }
    },
    setTaskOperation(param) {
      if (param.length > 0) {
        const routingOperations = []
        param.forEach((item) => {
          routingOperations.push({
            routingId: item.id,
            operationOrder: item.operationOrder,
            operationId: this.currOperationId
          })
        })
        this.taskMultipleSelection.forEach((el) => {
          el.operationId = this.currOperationId
          el.operationName = this.currOperationName
          el.routingOperations = routingOperations
        })
        this.$message.success('设置成功')
      }
    },
    submitTask() {
      if (this.taskMultipleSelection.length > 0) {
        // 必须要有起始工序、工艺路线
        let flag = true
        let flagMsg = ''
        const firstPartRoutingInfoArr = []
        this.taskMultipleSelection.forEach((item) => {
          if (item.routingOperations && item.routingOperations.length > 0) {
          } else {
            flag = false
            flagMsg = flagMsg + '零件：' + item.partName + '，需要起始工序；'
          }
          // 找出每个零件中，第一个的工序、工艺
          const firstPartRoutingInfo = firstPartRoutingInfoArr.find((ele) => {
            return ele.partId == item.partId
          })
          if (!firstPartRoutingInfo) {
            firstPartRoutingInfoArr.push({
              partId: item.partId,
              routingOperations: item.routingOperations
            })
          }
        })
        if (flag) {
          flagMsg = ''
          // 相同零件，工序、工艺必须相同
          this.taskMultipleSelection.forEach((item) => {
            // 找出每个零件中，第一个的工序、工艺
            const firstPartRoutingInfo = firstPartRoutingInfoArr.find((ele) => {
              return ele.partId == item.partId
            })
            if (firstPartRoutingInfo) {
              // 进行工序、工艺比较，数量的比较、品类的比较
              const routingOperations = item.routingOperations
              const firstPartRoutingOperations =
                firstPartRoutingInfo.routingOperations
              if (
                routingOperations.length != firstPartRoutingOperations.length
              ) {
                flag = false
                flagMsg =
                  flagMsg +
                  '零件：' +
                  item.partName +
                  '，工序、工艺路线不一致；'
              } else {
                for (let i = 0; i < routingOperations.length; i++) {
                  const existSameOperateAndRouting = firstPartRoutingOperations.find(
                    (f) => {
                      return (
                        f.operationId == routingOperations[i].operationId &&
                        f.routingId == routingOperations[i].routingId
                      )
                    }
                  )
                  if (!existSameOperateAndRouting) {
                    flag = false
                    flagMsg =
                      flagMsg +
                      '零件：' +
                      item.partName +
                      '，工序、工艺路线不一致；'
                  }
                }
              }
            }
          })
          if (flag) {
            // 弹出车间订单、是否生成批次选择框
            this.showGenerateTaskForm = true
          } else {
            this.$message.error(flagMsg)
          }
        } else {
          this.$message.error(flagMsg)
        }
      } else {
        this.$message.error('请选择需要提交的行')
      }
    },
    backTask() {
      if (this.taskMultipleSelection.length > 0) {
        const ids = []
        this.taskMultipleSelection.forEach((item) => {
          ids.push(item.id)
        })
        backProduceTask(ids).then((response) => {
          this.getTaskData()
          this.$message.success('退回成功')
        })
      } else {
        this.$message.error('请选择需要退回的行')
      }
    },
    handleClick(tab, event) {
      if (this.activeName == 'first') {
        this.getData()
      } else if (this.activeName == 'second') {
        this.getTaskData()
      } else {
        this.getTaskDetailData()
      }
    },
    // 根据订单号，查询对应成品零件列表
    taskQuerySegmentmerge() {
      this.taskSearchList[1].searchOptions = []
      const otcCustomerOrderNo = this.taskSearchList[0].value
      getPartsByOrderNo(otcCustomerOrderNo).then((response) => {
        const resData = response.data
        const partList = resData.data
        if (partList.length > 0) {
          const parts = []
          partList.forEach((item) => {
            parts.push({
              id: item.partId,
              name: item.partNo,
              desc: item.partName
            })
          })
          this.taskSearchList[1].searchOptions = parts
        }
      })
      this.getTaskData()
    },
    searchCusomterOrdersForDetail(query) {
      this.taskSearchList[0].searchOptions = []
      if (query !== '') {
        getAuditedOrderNoList(
          { current: 1, size: 20, customerOrderNo: query },
          1
        ).then((response) => {
          const resData = response.data.data.records
          const searchOptions = []
          resData.forEach((item) => {
            searchOptions.push({
              label: item,
              value: item
            })
          })
          this.taskDetailSearchList[0].searchOptions = searchOptions
        })
      }
    },
    searchCusomterOrdersForTask(query) {
      this.taskSearchList[0].searchOptions = []
      if (query !== '') {
        getAuditedOrderNoList(
          { current: 1, size: 20, customerOrderNo: query },
          1
        ).then((response) => {
          const resData = response.data.data.records
          const searchOptions = []
          resData.forEach((item) => {
            searchOptions.push({
              label: item,
              value: item
            })
          })
          this.taskSearchList[0].searchOptions = searchOptions
        })
      }
    },
    queryTaskSegmentmergeByOrderAndPartNo() {
      this.taskParamObj.otcCustomerOrderNo = this.taskSearchList[0].value
      this.taskParamObj.partId = this.taskSearchList[1].value
      this.getTaskData()
    },
    querySegmentmerge() {
      this.paramObj.otcCustomerOrderNo = this.searchList[0].value
      this.getData()
    },
    querySegmentmergeForDetail() {
      this.taskDetailParamObj.customerOrderNo = this.taskDetailSearchList[0].value
      const _that = this
      this.getTaskDetailData().then(() => {
        const dataList = _that.$refs.segmentmergeTaskDetailTable.getTableData()
        _that.taskDetailSearchList[1].value = dataList[0].customerName
      })
    },
    queryTaskDetail() {
      this.taskDetailParamObj.customerOrderNo = this.taskDetailSearchList[0].value
      this.taskDetailParamObj.customerName = this.taskDetailSearchList[1].value
      this.taskDetailParamObj.operationId = this.taskDetailSearchList[2].value
      this.getTaskDetailData()
    },
    searchCusomterOrders(query) {
      this.searchList[0].searchOptions = []
      if (query !== '') {
        getAuditedOrderNoList(
          { current: 1, size: 20, customerOrderNo: query },
          1
        ).then((response) => {
          const resData = response.data.data.records
          const searchOptions = []
          resData.forEach((item) => {
            searchOptions.push({
              label: item,
              value: item
            })
          })
          this.searchList[0].searchOptions = searchOptions
        })
      }
    },
    mergeSubmit() {
      const submitJsonArr = []
      this.multipleSelection.forEach((item) => {
        submitJsonArr.push({
          id: item.id,
          technologyDocumentId: item.technologyDocumentId,
          partId: item.partId,
          partName: item.partName,
          partNo: item.partNo,
          customerName: item.customerName
        })
      })
      submit(submitJsonArr, '01merge').then((response) => {
        this.$message.success('合并提交成功')
        this.getData()
      })
    },
    unMergeSubmit() {
      const submitJsonArr = []
      this.multipleSelection.forEach((item) => {
        submitJsonArr.push({
          id: item.id,
          technologyDocumentId: item.technologyDocumentId,
          partId: item.partId,
          partName: item.partName,
          partNo: item.partNo,
          customerName: item.customerName
        })
      })
      submit(submitJsonArr, '02split').then((response) => {
        this.$message.success('不合并提交成功')
        this.getData()
      })
    },
    saveSegment() {
      const saveJsonArr = []
      this.multipleSelection.forEach((item) => {
        saveJsonArr.push({
          id: item.id,
          qty: item.qty,
          discToolMeasurement: item.discToolMeasurement,
          selfNo: item.selfNo,
          print: item.print,
          direction: item.direction,
          section: item.section,
          begining: item.begining,
          ending: item.ending,
          purpose: item.purpose,
          endClassification: item.endClassification
        })
      })
      updateBatch(saveJsonArr).then((response) => {
        this.$message.success('保存成功')
        this.table.toolbar.forEach((ele) => {
          if (ele.text == '取消' || ele.text == '保存') {
            ele.barShow = false
          }
          if (ele.text == '编辑') {
            ele.barShow = true
          }
        })
        this.getData()
      })
    },
    getDisc() {
      if (this.multipleSelection.length > 0) {
        const requireParam = []
        this.multipleSelection.forEach((item) => {
          requireParam.push({
            discLength: item.qty,
            partId: item.partId,
            id: item.id
          })
        })
        getListByPartAndLength(requireParam).then((response) => {
          const resData = response.data
          if (resData.code == 0) {
            const respData = resData.data
            if (respData.length > 0) {
              this.multipleSelection.forEach((item) => {
                const matchItem = respData.find((el) => {
                  return item.id == el.id
                })
                if (matchItem) {
                  item.discToolMeasurement = matchItem.measurement
                }
              })
              // 批量更新盘具
              const saveJsonArr = []
              this.multipleSelection.forEach((item) => {
                saveJsonArr.push({
                  id: item.id,
                  discToolMeasurement: item.discToolMeasurement
                })
              })
              updateBatch(saveJsonArr).then((response) => {
                this.$message.success('更新盘具成功')
                this.getData()
              })
            } else {
              this.$message.error('未获取到合适的盘具')
            }
          }
        })
      } else {
        this.$message.error('请选择需要获取盘具的行')
      }
    },
    exportData() {
      if (this.searchList[0].value != null && this.searchList[0].value !== '') {
        exportTaskProduce({
          otcCustomerOrderNo: this.searchList[0].value
        }).then((response) => {
          transform(response)
        })
      } else {
        this.$message.error('请填写订单号，再进行导出')
      }
    },
    objectSpanMethod(data) {},
    objectSpanMethodForTaskDetail(data) {
      const row = data[0]
      const column = data[1]
      const rowIndex = data[2]
      const columnIndex = data[3]
      const mergeRowColSplitObj = data[5]
      if (column.property === 'qty' || column.property === 'snNo') {
        const rowColSplitNodes = mergeRowColSplitObj.snNo.rowColSplitNodes
        const rowColSplitNode = rowColSplitNodes.find(
          (item) => item.key == row.snNo && item.node === rowIndex
        )
        if (rowColSplitNode !== undefined) {
          data[4]({
            rowspan: rowColSplitNode.num,
            colspan: 1
          })
        } else {
          data[4]({
            rowspan: 0,
            colspan: 0
          })
        }
      }
      if (column.property === 'mergeSnNo') {
        const rowColSplitNodes = mergeRowColSplitObj.mergeSnNo.rowColSplitNodes
        const rowColSplitNode = rowColSplitNodes.find(
          (item) => item.key == row.mergeSnNo && item.node === rowIndex
        )
        if (rowColSplitNode !== undefined) {
          data[4]({
            rowspan: rowColSplitNode.num,
            colspan: 1
          })
        } else {
          data[4]({
            rowspan: 0,
            colspan: 0
          })
        }
      }
    },
    cancelEditRows() {
      const tableData = this.$refs.segmentmergeTable.getTableData()
      this.table.toolbar.forEach((ele) => {
        if (ele.text == '取消' || ele.text == '保存') {
          ele.barShow = false
        }
        if (ele.text == '编辑') {
          ele.barShow = true
        }
      })
      tableData.forEach((item) => {
        item.isRowEdit = false
      })
    },
    editRows() {
      if (this.multipleSelection.length > 0) {
        this.table.toolbar.forEach((ele) => {
          if (ele.text == '取消' || ele.text == '保存') {
            ele.barShow = true
          }
          if (ele.text == '编辑') {
            ele.barShow = false
          }
        })
        this.multipleSelection.forEach((item) => {
          item.isRowEdit = true
        })
      } else {
        this.$message.error('请选择需要编辑的行')
      }
    },
    // 获取数据列表
    getTaskDetailData() {
      return this.$refs.segmentmergeTaskDetailTable.getDataList()
    },
    // 获取数据列表
    getTaskData() {
      this.$refs.segmentmergeTaskTable.getDataList()
    },
    // 获取数据列表
    getData() {
      this.$refs.segmentmergeTable.getDataList()
    },
    handleSelectionChange(val) {
      this.multipleSelection = val
    },
    taskHandleSelectionChange(val) {
      this.taskMultipleSelection = val
      // 查询工序选择列表，初始化工序
      /* const ids = []
      this.taskMultipleSelection.forEach((item) => {
        ids.push(item.id)
      })
      getOperationsByTaskIds(ids).then((response) => {
        console.log('data', response.data)
      }) */
    },
    taskDetailHandleSelectionChange(val) {
      this.taskDetailMultipleSelection = val
    },
    openSelectOperate() {
      if (this.taskMultipleSelection.length > 0) {
        this.currOperationId = null
        this.currOperationName = null
        this.taskMultipleSelection.forEach((item) => {
          this.taskIds.push(item.id)
        })
        this.showOperateDialog = true
      } else {
        this.$message.error('请选择需要设置工序的行')
      }
    },
    setOperate(val) {
      if (val) {
        this.currOperationId = val.id
        this.currOperationName = val.name
      }
    },
    getMaterialType(type) {
      remote(type).then((response) => {
        const code = response.data.code
        if (code === 0) {
          const _data = response.data.data
          this.materialTypeList = _data
        }
      })
    },
    // 零件类型下拉框查询
    getMaterialTypeList() {
      return this.materialTypeList
    },
    getMaterialTypeType(row, column, cellValue) {
      this.materialTypeList.forEach((obj) => {
        if (obj.value == cellValue) {
          cellValue = obj.label
        }
      })
      return cellValue
    },
    getSomething() {},
    // 获取工序列表
    getOperationList() {
      getOperationList({ current: 1, size: 200 }).then((response) => {
        // this.operationList = response.data.data.records
        this.taskDetailSearchList[2].searchOptions = response.data.data.records
      })
    },
    printLabel() {
      if (this.taskDetailMultipleSelection.length > 0) {
        this.LODOP = getLodop()
        this.taskDetailMultipleSelection.forEach((item) => {
          this.createSmallLabel(item)
        })
      } else {
        this.$message.error('请选择需要打印的行')
      }
    },
    createSmallLabel(data) {
      this.LODOP.SET_LICENSES(
        '南通市鑫阳软件开发有限公司',
        '60F8E5078AE17DEB340C94BC7E83CAFF',
        '',
        ''
      )
      this.LODOP.PRINT_INITA(0, 0, 300, 100, '')
      this.LODOP.SET_PRINT_PAGESIZE(0, 600, 200, '')
      this.LODOP.SET_PRINT_MODE('PRINT_NOCOLLATE', 1)
      this.LODOP.ADD_PRINT_BARCODE(4, 25, 195, 18, '128Auto', data.sn)
      this.LODOP.SET_PRINT_STYLEA(0, 'ShowBarText', 0)
      this.LODOP.ADD_PRINT_TEXT(25, 25, 85, 20, '缆号：')
      this.LODOP.SET_PRINT_STYLEA(0, 'FontSize', 6)
      this.LODOP.ADD_PRINT_TEXT(25, 65, 105, 20, data.sn)
      this.LODOP.SET_PRINT_STYLEA(0, 'FontSize', 6)
      this.LODOP.ADD_PRINT_TEXT(26, 155, 126, 20, data.operationProduceQty)
      this.LODOP.SET_PRINT_STYLEA(0, 'FontSize', 7)
      this.LODOP.ADD_PRINT_TEXT(37, 25, 85, 20, '零件名称：')
      this.LODOP.SET_PRINT_STYLEA(0, 'FontSize', 6)
      this.LODOP.ADD_PRINT_TEXT(37, 75, 146, 35, data.partName)
      this.LODOP.SET_PRINT_STYLEA(0, 'FontSize', 6)
      this.LODOP.ADD_PRINT_TEXT(58, 25, 85, 20, '节距：')
      this.LODOP.SET_PRINT_STYLEA(0, 'FontSize', 6)
      this.LODOP.ADD_PRINT_TEXT(58, 65, 154, 31, data.partPitch)
      this.LODOP.SET_PRINT_STYLEA(0, 'FontSize', 6)
      this.LODOP.PRINT()
    }
  }
}
</script>
<style scoped>
.segmentmerge-operation-input >>> .el-input__inner {
  border-top-right-radius: 0px;
  border-bottom-right-radius: 0px;
  height: 28px;
  line-height: 28px;
}
.segmentmerge-operation-input >>> .el-input-group__append {
  border-top-right-radius: 0px;
  border-bottom-right-radius: 0px;
  height: 26px;
  line-height: 26px;
  padding-left: 3px;
  padding-right: 3px;
  width: 25px;
}
.segmentmerge-operation-input >>> .el-button {
  padding-left: 15px;
  padding-right: 15px;
}
.submit-task-button.el-button {
  padding-top: 7px !important;
  padding-bottom: 7px !important;
}
.segmentmerge-task-table >>> .cell {
  padding-left: 0px !important;
  padding-right: 0px !important;
}
</style>
